const JwtStrategy = require('passport-jwt').Strategy;
const ExtractJwt = require('passport-jwt').ExtractJwt;
const libs = `${process.cwd()}/libs`;
const config = require(`${libs}/config`);
const User = ('../models/user');

module.exports = function(passport){
    var opts = {};
    opts.jwtFromRequest = ExtractJwt.fromAuthHeader();
    opts.secretOrKey = config.get('mongodb:secret');
    passport.use(new JwtStrategy(opts, function(jwt_payload, done){
        User.find({id: jwt_payload.id}, function(err, user){
            if (err) {
                return done(err);
            }

            if (!user) {
                return done(null, false, {message: 'Unknown user'});
            }

            if (!user.comparePassword(password)) {
                return done(null, false, {message: 'Invalid password'});
            }

            return done(null, user);
        });
    }));
};
